Program Prisao;

Uses Dos, Crt, Printer;

Type

 St8  = String  [8];
 St50 = String [50];
 Conj_Artigos = Array [1..10] of Word;
 Registro_Principal = Record
                       Case Reg0: Boolean of
                        True: (Data_Criacao  : Array [1..3] of Word;
                               Data_Alteracao: Array [1..3] of Word;
                               Ultimo_Codigo : St8;
                               Ultimo_IndNome,
                               Ultimo_IndCod,
                               Numero_Presos: Word;); {Num.max presos}
                        False:(Codigo :  St8;
                               Nome   : St50;
                               Artigos: Conj_Artigos;);
                      End;
 Registro_Codigo = Record
                    Codigo: St8;
                    Estado: Boolean;
                    Endereco,
                    PT: Integer;
                   End;
 Registro_Nome = Record
                  Nome: St50;
                  Estado: Boolean;
                  Endereco,
                  PT: Integer;
                 End;
 Tipo_Arquivo = (Princ, Cod, Nom);
 TituloDaTela = String [20];
 MensagemErro = String [70];

Const

 ESC = #27;

Var
 Arq_Principal : File of Registro_Principal;
 Arq_Codigo    : File of Registro_Codigo;
 Arq_Nome      : File of Registro_Nome;
 Reg_Principal : Registro_Principal;
 Reg_Codigo    : Registro_Codigo;
 Reg_Nome      : Registro_Nome;
 Media,
 N,
 Ultimo_Nome,
 Ultimo_Cod    : Word;
 Cod_Corrente  : St8;
 Reg0          : Boolean;
 AA,
 MM,
 DD,
 DS            : Word;
 Op            : Byte;
 Resp          : Char;

Procedure Liga_Mensagem;

Const White_mais_Blink = 128 + 15;

Begin
 TextColor (White_mais_Blink);
 GotoXY (3, 22);
 Write ('MENSAGEM:');
 NormVideo;
End;

Procedure Desliga_Mensagem;

Begin
 GotoXY (2, 22);
 Write ('':78);
 GotoXY (2, 23);
 Write ('':78);
End;


{********************************************************************
 * Mostra a tela principal do programa prisao.                      *
 ********************************************************************}

Procedure InicieTela (TituloTela: TituloDaTela);

Var

 Traco: Array [1..78] of Char;
 Contador: Byte;

Begin
 NormVideo;
 TextBackGround (Black);
 ClrScr;
 FillChar (Traco, 78, Ord (''));
 GotoXY (1,1);
 Write ('',Traco,'');
 For Contador:=2 to 23 do
  Begin
   GotoXY (1,Contador);
   Write ('');
   GotoXY (80,Contador);
   Write ('');
  End;
 Write ('',Traco,'');
 GotoXY (1,4);
 Write ('',Traco,'');
 GotoXY (1,21);
 Write ('',Traco,'');
 TextBackGround (Blue);
 HighVideo;
 GotoXY (2,2);
 Write ('':22,'Sistema de Controle de Pessoal.');
 GotoXY (55, 2);
 Write ('':25);
 GotoXY (2, 3);
 Write ('   Presidio: ABC                          ');
 GotoXY (43,3);
 Write ('':37);
 GotoXY (56,3);
 Write (TituloTela);
 TextBackGround (Black);
 NormVideo;
End;

Procedure Entra_Nome (Var Nome:St50);

Begin
 GotoXY (10, 7);
 Write ('Nome:__________________________________________________!');
 GotoXY (15, 7);
 ReadLn (Nome);
End;

Procedure Mostra_Nome (Nome:St50);

Begin
 GotoXY (10, 7);
 Write ('Nome:__________________________________________________!');
 GotoXY (15, 7);
 Write (Nome);
End;

Procedure Entra_Codigo (Var Codigo:St8);

Begin
 GotoXY (10, 8);
 Write ('Codigo:________!');
 GotoXY (17, 8);
 ReadLn (Codigo);
End;

Procedure Mostra_Codigo (Codigo:St8);

Begin
 GotoXY (10, 8);
 Write ('Codigo:________!');
 GotoXY (17, 8);
 Write (Codigo);
End;

Procedure Entra_Artigos (Var Artigos: Conj_Artigos);

Const Sobe = #72;
      Desce = #80;
      BkSpc = #8;
Var

 I: Byte;
 Tecla: Char;

Begin
 GotoXY (10, 9);
 Write ('Artigos Infringidos:');
 For I:=1 to 10 do
  Begin
   GotoXY (31, 8+I);
   Write (I:2,':',Artigos[I]:5,'!');
  End;
 I:=1;
 Repeat
  GotoXY (38, 8+I);
  Repeat
   Tecla:=ReadKey;
  Until (Tecla = Chr (13)) or
        ((Tecla >= '0') and (Tecla <= '9')) or
        (Tecla = Sobe) or
        (Tecla = Bkspc) or
        (Tecla = Desce);
  If Tecla = Chr (13) Then
   If Artigos[I]=0 Then
    I:=11
   Else
    Inc (I);
   If ((Tecla >= '0') and (Tecla <= '9')) and (Artigos [I] < 10000) Then
    Begin
     Artigos[I]:=Artigos[I]*10;
     Inc (Artigos[I],(Ord (Tecla)-48));
     GotoXY (31, 8+I);
     Write (I:2,':',Artigos[I]:5,'!');
    End;
   If (Tecla = Bkspc) and (Artigos[i] > 0) Then
    Begin
     Artigos[I]:=Artigos[I] div 10;
     GotoXY (31, 8+I);
     Write (I:2,':',Artigos[I]:5,'!');
    End;
   If (Tecla = Sobe) and (I > 1) Then
    Dec (I);
   If (Tecla = Desce) and (I < 10) Then
    Inc (I);
 Until I = 11;
End;

Procedure Mostra_Artigos (Artigos: Conj_Artigos);

Var

 I: Byte;

Begin
 GotoXY (10, 9);
 Write ('Artigos Infringidos:');
 For I:=1 to 10 do
  Begin
   GotoXY (31, 8+I);
   Write (I:2,':',Artigos[I]:5,'!');
  End;
End;

Procedure Limpa_Tela_Interna;

Var Cont: Byte;

Begin
 For Cont:=5 to 19 do
  Begin
   GotoXY (2, Cont);
   Write ('':78);
  End;
End;

{********************************************************************
 * Escolhe a mensagem de erro que sera impressa na tela.            *
 ********************************************************************}

Procedure Erro_Abertura (I: Integer);

Var Erro: MensagemErro;

 {********************************************************************
  * Imprime mensagem de erro e pede ao usuario para seguir ou abortar*
  ********************************************************************}

 Procedure EmitaErro (Frase: MensagemErro);

 Var

  Tecla: Char;
  x: Integer;

 Begin
  GotoXY (3,18);
  Write ('Mensagem: ',Frase,' <ENTER>');
  GotoXY (3,22);
  Write (' Digite (T) para tentar novamente ou <ESC> para abortar ');
  Tecla:=ReadKey;
  If Tecla = ESC Then
   Begin
    ClrScr;
    Halt;
   End;
  GotoXY (3,18);
  Write (' ':76);
  GotoXY (3,22);
  Write (' ':76);
 End;

Begin
 Case I of
  1: Erro:='ERRO na abertura do arquivo principal !';
  2: Erro:='ERRO na abertura do arquivo Indice de codigos !';
  3: Erro:='ERRO na abertura do arquivo Indice de nomes !';
  4: Erro:='ERRO na geracao do arquivo principal !';
  5: Erro:='ERRO na geracao do arquivo Indice de codigos !';
  6: Erro:='ERRO na geracao do arquivo Indice de nomes !';
  7: Erro:='ERRO na gravacao do arquivo principal !';
  8: Erro:='ERRO na gravacao do arquivo Indice de codigos !';
  9: Erro:='ERRO na gravacao do arquivo Indice de nomes !';
 10: Erro:='ERRO na leitura do arquivo principal !';
 11: Erro:='ERRO na leitura do arquivo Indice de codigos !';
 12: Erro:='ERRO na leitura do arquivo Indice de nomes !';
 End;
 EmitaErro (Erro);
End;

{********************************************************************
 *  Abre qualquer um dos tres arquivos.                             *
 ********************************************************************}

Procedure Abrir_Arquivo (Tipo_Arq: Tipo_Arquivo);

Var ERRO: Integer;

Begin
 Repeat
 {$I-}
 Case Tipo_Arq of
  Princ : Reset(Arq_Principal);
  Cod   : Reset(Arq_Codigo);
  Nom   : Reset(Arq_Nome);
 End;
 {$I+}
 ERRO:=IOResult;
 If ERRO<>0 Then
   Erro_Abertura (Integer(Tipo_Arq)+1);
 Until ERRO = 0;
End;

{********************************************************************
 * Cria qualquer um dos tres arquivos.                              *
 ********************************************************************}

Procedure Criar_Arquivo (Tipo_arq: Tipo_Arquivo);

Var ERRO : Integer;

Begin
 Repeat
  {$I-}
  Case Tipo_Arq of
   Princ : Rewrite(Arq_Principal);
   Cod   : Rewrite(Arq_Codigo);
   Nom   : Rewrite(Arq_Nome);
  End;
  {$I+}
  ERRO:=IOResult;
  If ERRO<>0 Then
    Erro_Abertura(Integer(Tipo_Arq)+4);
 Until ERRO=0;
End;

{********************************************************************
 * Escreve no arquivo principal. Obs: Nao posiciona o apont.do arq. *
 ********************************************************************}

Procedure Escreva_Arq_Principal (Reg: Registro_Principal);

Var ERRO: Integer;

Begin
 Repeat
  {$I-}
  Write(Arq_Principal, Reg);
  {$I+}
  ERRO:=IOResult;
  if ERRO<>0 Then
    Erro_Abertura(7);
 Until ERRO=0;
End;

{********************************************************************
 * Escreve no arquivo de codigos. Obs:Nao posiciona o apont.do arq. *
 ********************************************************************}

Procedure Escreva_Arq_Codigo (Reg: Registro_Codigo);

Var ERRO:Integer;

Begin
 Repeat
  {$I-}
  Write(Arq_Codigo, Reg);
  {$I+}
  ERRO:=IOResult;
  if ERRO<>0 Then
    Erro_Abertura(8);
 Until ERRO=0;
End;

{********************************************************************
 * Escreve no arquivo de nomes.  Obs: Nao posiciona o apont.do arq. *
 ********************************************************************}

Procedure Escreva_Arq_Nome(Reg:Registro_Nome);

Var ERRO:Integer;

Begin
 Repeat
  {$I-}
  Write(Arq_Nome, Reg);
  {$I+}
  ERRO:=IOResult;
  if ERRO<>0 Then
    Erro_Abertura(9);
 Until ERRO=0;
End;

{********************************************************************
 * Le o arquivo principal. Obs: Nao posiciona o apont.do arq.       *
 ********************************************************************}

Procedure Leia_Arq_Principal (Var Reg: Registro_Principal);

Var ERRO:Integer;

Begin
 Repeat
  {$I-}
  Read(Arq_Principal,Reg);
  {$I+}
  ERRO:=IOResult;
  if ERRO<>0 Then
   Erro_Abertura(10);
 Until ERRO=0;
End;

{********************************************************************
 * Le o arquivo de codigos. Obs :Nao posiciona o apont.do arq.      *
 ********************************************************************}

Procedure Leia_Arq_Codigo(Var Reg:Registro_Codigo);

Var ERRO:Integer;

Begin
 Repeat
  {$I-}
  Read(Arq_Codigo,Reg);
  {$I+}
  ERRO:=IOResult;
  if ERRO<>0 Then
    Erro_Abertura(11);
 Until ERRO=0;
End;

{********************************************************************
 * Le o arquivo de nomes.  Obs: Nao posiciona o apont.do arq.       *
 ********************************************************************}

Procedure Leia_Arq_Nome(Var Reg:Registro_Nome);

Var ERRO:Integer;

Begin
 Repeat
  {$I-}
  Read(Arq_Nome,Reg);
  {$I+}
  ERRO:=IOResult;
  if ERRO<>0 Then
    Erro_Abertura(12);
 Until ERRO=0;
End;

{********************************************************************
 * Gera um numero primo logo apos do numero dados.                  *
 ********************************************************************}

Function Primo (N: Word): Word;

Var X: Word;

Begin
 If (N mod 2) = 0 Then Inc (N);
 X:=3;
 While (X<N) do
  Begin
   While (N mod X) = 0 do Inc (N);
   Inc (X, 2)
  End;
 Primo:=N;
 If N<2 Then Primo:=2
End;


{********************************************************************
 * Cria todos os arquivos deixando todos zerados e preparados.      *
 ********************************************************************}

Procedure Criar_Banco_de_Dados(N: Word); {N e o numero maximo de detentos.}

Var

   Contador: Integer;
   ERRO: Byte;

Begin
 Media := Primo (N Div 10);
 Assign (Arq_Principal, 'Prisao.dat');
 Assign (Arq_Codigo, 'Codigo.ndx');
 Assign (Arq_Nome, 'Nome.ndx');
 Criar_Arquivo (Princ);
 Criar_arquivo (Nom);
 Criar_arquivo (Cod);
 With Reg_Principal do
  Begin
   Reg0:=True;
   Data_Criacao[1]:=DD;
   Data_Criacao[2]:=MM;
   Data_Criacao[3]:=AA;
   Data_Alteracao[1]:=DD;
   Data_Alteracao[2]:=MM;
   Data_Alteracao[3]:=AA;
   Ultimo_Codigo:='000000-0';
   Ultimo_IndNome:=Media+1;
   Ultimo_IndCod :=Media+1;
   Numero_Presos:=N;
  End;
 {$I-}
 Escreva_Arq_Principal (Reg_Principal);
 With Reg_Codigo do
  Begin
   Codigo:='';
   Estado:=False;
   Endereco:=0;
   PT:=-1;
  End;
 With Reg_Nome do
  Begin
   Nome:='';
   Estado:=False;
   Endereco:=0;
   PT:=-1;
  End;
 For Contador:=1 to Media do
  Begin
   Escreva_Arq_Codigo (Reg_Codigo);
   Escreva_Arq_Nome (Reg_Nome);
  End;
 {$I+}
 Reg0:=False;
 Close(Arq_Principal);
 Close(Arq_Nome);
 Close(Arq_Codigo);
End;

{********************************************************************
 * Resgata o primeiro registro do arquivo principal (Inf.Gerais.) e *
 * pede confirmacao da data ao usuario e pede uma reentrada da data *
 * caso ela esteja errada.                                          *
 ********************************************************************}

Procedure Iniciar_Utilizacao;

Var

 Data: String [8];
 Erro: Byte;
 Resp: Char;
 SDD, SMM, SAA: String [2];
 Erro1, Erro2, Erro3: Integer;

Begin
 GetDate(AA,MM,DD,DS);
 If AA<2000
  Then AA:=AA-1900
  Else AA:=AA-2000;
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('Data atual: ',DD,'/',MM,'/',AA,'. Ela esta correta? [ ] (S/N) ');
 Repeat
  GotoXY (53, 22);
  Resp:=ReadKey;
 Until (UpCase (Resp)='S') or (UpCase (Resp)='N');
 GotoXY (53, 22);
 Write (Resp);
 Delay (200);
 Desliga_Mensagem;
 If UpCase (Resp)='N' Then
  Begin
   Repeat
    Liga_Mensagem;
    GotoXY (13, 22);
    Write ('Entre com a nova data no formato "DD/MM/AA":__/__/__!');
    GotoXY (57, 22);
    ReadLn (Data);
    SDD:=Copy (Data, 1, 2);
    SMM:=Copy (Data, 4, 2);
    SAA:=Copy (Data, 7, 2);
    Val (SDD, DD, Erro1);
    Val (SMM, MM, Erro2);
    Val (SAA, AA, Erro3);
    Desliga_Mensagem;
   Until (Erro1=0) and (Erro2=0) and (Erro3=0);
   If AA<91
    Then AA:=AA+2000
    Else AA:=AA+1900;
   SetDate (AA,MM,DD);
  End;
 Assign(Arq_Principal, 'Prisao.dat');
 Assign(Arq_Codigo, 'Codigo.ndx');
 Assign(Arq_Nome, 'Nome.ndx');
 Reg0:=True;
 Abrir_Arquivo (Princ);
 Leia_Arq_Principal (Reg_Principal);
 Cod_Corrente:=Reg_Principal.Ultimo_Codigo;
 Ultimo_Nome:=Reg_Principal.Ultimo_IndNome;
 Ultimo_Cod:=Reg_Principal.Ultimo_IndCod;
 N:=Reg_Principal.Numero_Presos;
 Media := Primo (N Div 10);
 Reg0:=False;
End;

{********************************************************************
 * Finaliza a utilizacao do programa atualizando o primeiro registro*
 * do arq.principal (inf.gerais).                                   *
 ********************************************************************}

Procedure Finalizar_Utilizacao;

Var Erro: Byte;

Begin
 Reg0:=True;
 Abrir_Arquivo(Princ);
 Leia_Arq_Principal (Reg_Principal);
 With Reg_Principal do
  Begin
   Data_Alteracao[1]:=DD;
   Data_Alteracao[2]:=MM;
   Data_Alteracao[3]:=AA;
   Ultimo_Codigo:=Cod_Corrente;
   Ultimo_IndNome:=Ultimo_Nome;
   Ultimo_IndCod :=Ultimo_Cod;
  End;
 Abrir_Arquivo(Nom);
 Abrir_Arquivo(Cod);
 Abrir_Arquivo(Princ);
 Escreva_Arq_Principal(Reg_Principal);
 Reg0:=False;
 Close(Arq_Principal);
 Close(Arq_Nome);
 Close(Arq_Codigo);
End;

{********************************************************************
 * Finaliza a utilizacao do programa atualizando o primeiro registro*
 * do arq.principal (inf.gerais).                                   *
 ********************************************************************}

Function h (x:St50) :Integer;

Var

   I,AUX : Integer;

Begin
 AUX:=0;
 For I:=1 to Length(x) do
   AUX:=AUX+Ord(x[I]);
 h:=AUX mod Media;
End;

{********************************************************************
 * Pede confirmacao ao usuario do registro encontrado.              *
 ********************************************************************}

Function Confirma_Registro (Reg: Registro_Principal):Boolean;

Var Respost:Char;

Begin
 Mostra_Nome (Reg.Nome);
 Mostra_Codigo (Reg.Codigo);
 Mostra_Artigos (Reg.Artigos);
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('Confirma este registro? [ ] (S/N).');
 Repeat
  GotoXY (38, 22);
  Respost:=ReadKey;
 Until (UpCase (Respost) = 'S') or (UpCase (Respost) = 'N');
 GotoXY (38, 22);
 Write (Respost);
 Delay (200);
 If (UpCase (Respost) = 'S')
   Then Confirma_Registro:=True
   Else Confirma_Registro:=False;
 Desliga_Mensagem;
End;

{********************************************************************
 * Procura um registro atraves do nome e retorna o registro princip.*
 * e seu indice  ou indice '-1' se nao o encontrar.                 *
 ********************************************************************}

Procedure Busca_Por_Nome (x:St50;Var Reg_Principal:Registro_Principal;
                        Var I: Integer);

Var
   SN       : Char;
   Reg_Nome : Registro_Nome;
   Escolheu : Boolean;

Begin
 Escolheu:=False;
 I:=h(x);
 Abrir_Arquivo (Nom);
 Abrir_Arquivo (Princ);
 Leia_Arq_Principal (Reg_Principal);
 If EOF(Arq_Principal) Then I:=-1
 Else
  Begin
   Repeat
    Seek(Arq_Nome,I);
    Leia_Arq_Nome(Reg_Nome);
    If (Reg_Nome.Nome = x) and Reg_Nome.Estado Then
     Begin
      Seek (Arq_Principal, Reg_Nome.Endereco);
      Leia_Arq_Principal (Reg_Principal);
      Escolheu:=Confirma_Registro (Reg_Principal);
     End;
    If not Escolheu Then I:=Reg_Nome.PT;
   Until (Reg_Nome.PT=-1) or (Escolheu);
   If Escolheu Then
    Begin
     Seek(Arq_Principal,Reg_Nome.Endereco);
     Leia_Arq_Principal(Reg_Principal);
    End
   Else
    I:=-1;
  End;
End;

{********************************************************************
 * Procura um registro atravez do codigo e retorna o reg. princip.  *
 * e seu indice  ou indice '-1' se nao o encontrar.                 *
 ********************************************************************}

Procedure Busca_Por_Codigo(x:St8;Var Reg_Principal:Registro_Principal;
                           Var I: Integer);

Var
   Reg_Codigo : Registro_Codigo;
   Achou      : Boolean;

Begin
 Achou:=False;
 I:=h(x);
 Abrir_Arquivo(Cod);
 Abrir_Arquivo(Princ);
 Leia_Arq_Principal(Reg_Principal);
 If EOF(Arq_Principal) Then I:=-1
 Else
  Begin
   Repeat
    Seek(Arq_Codigo,I);
    Leia_Arq_Codigo(Reg_Codigo);
    If (Reg_Codigo.Codigo = x) and Reg_Codigo.Estado Then
     Achou:=True;
    If not Achou Then I:=Reg_Codigo.PT;
   Until (Reg_Codigo.PT=-1) or (Achou);
   If Achou Then
    Begin
     Seek(Arq_Principal,Reg_Codigo.Endereco);
     Leia_Arq_Principal(Reg_Principal);
    End
   Else
    I:=-1;
  End;
End;

{********************************************************************
 * Pede ao usuario que entre com os dados de um detento e retorna   *
 * um registro com o codigo ja calculado.                           *
 ********************************************************************}

Procedure Carregar_Registro_Principal (Var Reg:Registro_Principal);

Var
    AUX,COD,DIG : Word;
    ERRO : Integer;
    Codigo,Ano,Digito : St8;

Begin
 FillChar (Reg, SizeOf (Reg),0);
 Entra_Nome (Reg.Nome);
 Val(Copy(Cod_Corrente,1,2),AUX,ERRO);
 Val(Copy(Cod_Corrente,3,4),COD,ERRO);
 Inc(COD);
 DIG:=Trunc((AA+COD) mod 10);    {Digito verificador}
 Str(COD,Codigo);
 While(Length(Codigo)<4) do
   Codigo:=Concat('0',Codigo);
 Str(AA,Ano);
 Str(DIG,Digito);
 Codigo:=Concat(Ano,Codigo,'-',Digito);
 Reg.Codigo:=Codigo;
 Cod_Corrente:=Codigo;
 Mostra_Codigo (Codigo);
 Entra_Artigos (Reg.Artigos);
 Limpa_Tela_Interna;
End;

{********************************************************************
 * Coloca um registro no arquivo principal e atualizando os arquivos*
 * de indices (o de nome e o de codigo).                            *
 ********************************************************************}

Procedure Insira (Reg_Principal: Registro_Principal);

Var Numero : Word;
    Hashing: Word;
    Gravou: Boolean;
    Posicao: Word;
    Resp: Char;

Begin
 Abrir_Arquivo(Princ);
 If (FileSize (Arq_Principal)-1)>=N Then
  Begin
   Liga_Mensagem;
   GotoXY (13, 22);
   Write ('O arquivo esta cheio, nao se pode incluir nenhum registro.');
   GotoXY (13, 23);
   Write ('Tecle <Enter> para prosseguir:');
   Resp:=ReadKey;
   Desliga_Mensagem;
  End
 Else
  Begin
   Numero:=FileSize (Arq_Principal);
   Abrir_Arquivo(Cod);
   Gravou:=False;
   Hashing:=h(Reg_Principal.Codigo);
   While (Not Gravou) do
    Begin
     Seek (Arq_Codigo, Hashing);
     Leia_Arq_Codigo (Reg_Codigo);
     If Reg_Codigo.Codigo <> '' Then
      If Reg_Codigo.PT = -1 Then
       Begin
        Abrir_Arquivo (Cod);
        Posicao:=FileSize (Arq_Codigo);
        Seek (Arq_Codigo, Hashing);
        Leia_Arq_Codigo (Reg_Codigo);
        Reg_Codigo.Pt:=Posicao;
        Seek (Arq_Codigo, Hashing);
        Escreva_Arq_Codigo (Reg_Codigo);
        Seek (Arq_Codigo, Posicao);
        With Reg_Codigo do
         Begin
          Codigo:=Reg_Principal.Codigo;
          Estado:=True;{Ativo}
          Endereco:=Numero;
          PT:=-1;
         End;
        Escreva_Arq_Codigo (Reg_Codigo);
        Gravou:=True
       End
      Else
        Hashing:=Reg_Codigo.PT
     Else
      Begin
       Seek (Arq_Codigo, Hashing);
       With Reg_Codigo do
        Begin
         Codigo:=Reg_Principal.Codigo;
         Estado:=True;{Ativo}
         Endereco:=Numero;
         PT:=-1;
        End;
       Escreva_Arq_Codigo (Reg_Codigo);
       Gravou:=True
      End;
    End;
   Abrir_Arquivo(Nom);
   Gravou:=False;
   Hashing:=h(Reg_Principal.Nome);
   While (Not Gravou) do
    Begin
     Seek (Arq_Nome, Hashing);
     Leia_Arq_Nome (Reg_Nome);
     If Reg_Nome.Nome <> '' Then
      If Reg_Nome.PT = -1 Then
       Begin
        Abrir_Arquivo (Nom);
        Posicao:=FileSize (Arq_Nome);
        Seek (Arq_Nome, Hashing);
        Leia_Arq_Nome (Reg_Nome);
        Reg_Nome.Pt:=Posicao;
        Seek (Arq_Nome, Hashing);
        Escreva_Arq_Nome (Reg_Nome);
        Seek (Arq_Nome, Posicao);
        With Reg_Nome do
         Begin
          Nome:=Reg_Principal.Nome;
          Estado:=True;{Ativo}
          Endereco:=Numero;
          PT:=-1;
         End;
        Escreva_Arq_Nome (Reg_Nome);
        Gravou:=True
       End
      Else
       Hashing:=Reg_Nome.PT
     Else
      Begin
       Seek (Arq_Nome, Hashing);
       With Reg_Nome do
        Begin
         Nome:=Reg_Principal.Nome;
         Estado:=True;{Ativo}
         Endereco:=Numero;
         PT:=-1;
        End;
       Escreva_Arq_Nome (Reg_Nome);
       Gravou:=True
      End;
    End;
   Seek (Arq_Principal, Numero);
   Escreva_Arq_Principal(Reg_Principal);
  End;
End;

{********************************************************************
 * Executa a sequencia de entrada, carregando o registro do teclado *
 * e gravando em arquivo                                            *
 ********************************************************************}


Procedure Inserir;
Begin
 Carregar_Registro_Principal(Reg_Principal);
 Insira(Reg_Principal);
End;

Procedure Pesquisar;
Var
 Nome: St50;
 Codigo: St8;
 Ch: Char;
 I: Integer;
Begin
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('Pesquisar por nome ou por codigo? [ ] (N/C).');
 Repeat
  GotoXY (48, 22);
  Ch:=ReadKey;
 Until (UpCase (Ch)='N') or (UpCase (Ch)='C');
 GotoXY (48, 22);
 Write (Ch);
 Delay (200);
 Desliga_Mensagem;
 If (UpCase (Ch) = 'N') Then
  Begin
   Entra_Nome (Nome);
   Busca_por_Nome (Nome, Reg_Principal, I);
  End
 Else
  Begin
   Entra_Codigo (Codigo);
   Busca_por_Codigo (Codigo, Reg_Principal, I);
  End;
   If (I<>-1) Then
     With Reg_Principal do
      Begin
       Mostra_Nome (Nome);
       Mostra_Codigo (Codigo);
       Mostra_Artigos (Artigos);
       Liga_Mensagem;
       GotoXY (13, 22);
       Write ('Tecle <Enter> para prosseguir.');
       Resp:=ReadKey;
       Desliga_Mensagem;
      End
     Else
      Begin
       Liga_Mensagem;
       GotoXY (13, 22);
       Write ('Registro nao cadastrado.');
       GotoXY (13, 23);
       Write ('Tecle <Enter> para prosseguir');
       Resp:=ReadKey;
       Desliga_Mensagem;
      End;
 Limpa_Tela_Interna;
End;


{********************************************************************
 * Imprime dados de um preso                                        *
 ********************************************************************}

Procedure Liste_Registro (Reg:Registro_Principal);

Var f : Integer;
    Ch : Char;
Begin
 Mostra_Nome (Reg.Nome);
 Mostra_Codigo (Reg.Codigo);
 Mostra_Artigos (Reg.Artigos);
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('Tecle <Enter> para prosseguir.');
 Ch:=ReadKey;
 Limpa_Tela_Interna;
 Desliga_Mensagem;
End;


Procedure Liste_Registro_Impressora (Reg:Registro_Principal);

Var  I: Byte;

Begin
 Write (Lst, Reg.Codigo);
 WriteLn (Lst, Reg.Nome);
 Write (Lst, 'Artigos:');
 For I:=1 to 10 do
  Write (Lst, Reg.Artigos [I]:6);
 WriteLn (Lst);
 WriteLn (Lst);
End;


{********************************************************************
 * Lista todos os detentos. (True - ativos, False - nao ativos)     *
 ********************************************************************}

Procedure Listar (Tipo, Impressora:Boolean);

Begin
 Abrir_Arquivo(Princ);
 Abrir_Arquivo(Nom);
 While(Not EOF(Arq_Nome)) do
  Begin
   Leia_Arq_Nome(Reg_Nome);
   If (Reg_Nome.Estado=Tipo)and
      (Reg_Nome.Endereco<>0) Then
    Begin
     Abrir_Arquivo(Princ);
     Seek(Arq_Principal,Reg_Nome.Endereco);
     Leia_Arq_Principal(Reg_Principal);
     If Impressora Then
      Liste_Registro_Impressora (Reg_Principal)
     Else
      Liste_Registro(Reg_Principal);
    End;
  End;
End;

Procedure Deletar_Nome(I:Integer);
Begin
 Abrir_Arquivo(Nom);
 Seek(Arq_Nome,I);
 Leia_Arq_Nome(Reg_Nome);
 Abrir_Arquivo(Nom);
 Seek(Arq_Nome,I);
 Reg_Nome.Estado:=False;
 Escreva_Arq_Nome(Reg_Nome);
End;

Procedure Deletar_Codigo(I:Integer);
Begin
 Abrir_Arquivo(Cod);
 Seek(Arq_Codigo,I);
 Leia_Arq_Codigo(Reg_Codigo);
 Abrir_Arquivo(Cod);
 Seek(Arq_Codigo,I);
 Reg_Codigo.Estado:=False;
 Escreva_Arq_Codigo(Reg_Codigo);
End;


Procedure Delete_por_Nome(Chave:St50);

Var Reg: Registro_Principal;
    Indice : Integer;
    Resp: Char;

Begin
 Busca_Por_Nome(Chave,Reg,Indice);
 If Indice<>-1 Then
  Begin
   Deletar_Nome(Indice);
   Busca_Por_Codigo(Reg.Codigo,Reg,Indice);
   Deletar_Codigo(Indice);
  End
 Else
  Begin
   Liga_Mensagem;
   GotoXY (13, 22);
   Write ('Nao existe este registro.');
   GotoXY (13, 23);
   Write ('Tecle <Enter> para prosseguir');
   Resp:=ReadKey;
   Desliga_Mensagem;
  End;
End;

Procedure Delete_por_Codigo(Chave:St8);
Var Reg: Registro_Principal;
    Indice : Integer;
    Escolheu : Boolean;

Begin
 Busca_Por_Codigo(Chave,Reg,Indice);
 If Indice<>-1 Then
 Begin
 Deletar_Codigo(Indice);
 Indice:=h(Reg.Nome);
 Abrir_Arquivo(Nom);
 Abrir_Arquivo(Princ);
 Repeat
  Seek(Arq_Nome,Indice);
  Leia_Arq_Nome(Reg_Nome);
  Seek(Arq_Principal,Reg_Nome.Endereco);
  Leia_Arq_Principal(Reg_Principal);
  If Reg_Nome.Nome = Reg.Nome Then
   If Reg_Principal.Codigo = Reg.Codigo Then
      Escolheu:=True;
  If not Escolheu Then Indice:=Reg_Nome.PT;
 Until (Reg_Nome.PT=-1) or (Escolheu);   {prevencao contra erro}
 If Escolheu Then
  Begin
   Reg_Nome.Estado:=False;
   Abrir_Arquivo(Nom);
   Seek(Arq_Nome,Indice);
   Escreva_Arq_Nome(Reg_Nome);
  End
 Else
  Begin
   Liga_Mensagem;
   GotoXY (13, 22);
   Write ('Erro grave na exclusao no arquivo de nomes!!!');
   GotoXY (13, 23);
   Write ('Tecle <Enter> para prosseguir');
   Resp:=ReadKey;
   Desliga_Mensagem;
  End;
 End
 Else
  Begin
   Liga_Mensagem;
   GotoXY (13, 22);
   Write ('Nao existe este registro, impossivel excluir.');
   GotoXY (13, 23);
   Write ('Tecle <Enter> para prosseguir');
   Resp:=ReadKey;
   Desliga_Mensagem;
  End;
End;


Procedure Excluir;

Var

 Nome: St50;
 Codigo: St8;
 Ch: Char;
 I: Integer;

Begin
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('Excluir por nome ou codigo? [ ] (N/C)');
 Repeat
  GotoXY (42, 22);
  Ch:=ReadKey;
 Until (UpCase (Ch) = 'N') or (Upcase (Ch) = 'C');
 GotoXY (42, 22);
 Write (Ch);
 Delay (200);
 Desliga_Mensagem;
 If (UpCase (Ch) = 'N') Then
  Begin
   Entra_Nome (Nome);
   Delete_Por_Nome (Nome);
  End
 Else
  Begin
   Entra_Codigo (Codigo);
   Delete_Por_Codigo (Codigo);
  End;
 Limpa_Tela_Interna;
End;


Procedure Reorganizar_Banco_de_Dados;

Var Arq_Princaux : File of Registro_Principal;
    Arq_Codaux   : File of Registro_Codigo;
    Arq_Nomaux   : File of Registro_Nome;
    Reg: Registro_Principal;
    Escolheu : Boolean;

Begin
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('Aguarde um instante. Reorganizando...');

 Finalizar_Utilizacao;

 Assign(Arq_Principal,'Prisao.dat');
 Assign(Arq_Codigo,'Codigo.ndx');
 Assign(Arq_Nome,'Nome.ndx');

 Rename (Arq_Principal,'Prisao.tmp');
 Rename (Arq_Codigo,'Codigo.tmp');

 Assign(Arq_Princaux,'Prisao.tmp');
 Assign(Arq_Codaux,'Codigo.tmp');

 Reg0:=True;
 Reset(Arq_Princaux);
 Read(Arq_Princaux,Reg_Principal);
 Cod_Corrente:=Reg_Principal.Ultimo_Codigo;
 N:=Reg_Principal.Numero_Presos;
 Criar_Banco_de_Dados(N);
 Abrir_Arquivo(Nom);
 Abrir_Arquivo(Cod);
 Abrir_Arquivo(Princ);
 Read(Arq_Principal,Reg_Principal);
 Reg_Principal.Ultimo_Codigo:=Cod_Corrente;
 Abrir_Arquivo(Princ);
 Escreva_Arq_Principal(Reg_Principal);
 Reg0:=False;
 Reset(Arq_Codaux);
 While(Not EOF(Arq_Codaux)) do
  Begin
   Read(Arq_Codaux,Reg_Codigo);
   If Reg_Codigo.Estado Then
    Begin
     Seek(Arq_Princaux,Reg_Codigo.Endereco);
     Read(Arq_Princaux,Reg_Principal);
     Insira(Reg_Principal);
    End;
  End;
 Close(Arq_Principal);
 Close(Arq_Codigo);
 Close(Arq_Nome);
 Close(Arq_Princaux);
 Close(Arq_Codaux);
 Erase(Arq_Princaux);
 Erase(Arq_Codaux);
 Desliga_Mensagem;
 Iniciar_Utilizacao;
End;

Procedure Criar_BD;

Var Resp: Char;

Begin
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('Os arquivos nao estao disponiveis! Devo criar-los? [ ] (S/N).');
 GotoXY (3, 23);
 Write ('Obs: Se os arquivos existem, nao se deve cria-los pois isso os apagara!');
 Repeat
  GotoXY (65, 22);
  Resp:=ReadKey;
 Until (UpCase (Resp)='S') or (UpCase (Resp)='N');
 GotoXY (65, 22);
 Write (Resp);
 Delay (200);
 Desliga_Mensagem;
 If UpCase (Resp) = 'S' Then
  Begin
   Liga_Mensagem;
   GotoXY (13, 22);
   Write('Digite o numero maximo de presos a serem cadastrados:______! ');
   GotoXY (66, 22);
   ReadLn (N);
   Desliga_Mensagem;
   Liga_Mensagem;
   GotoXY (13, 22);
   WriteLn ('Espere um instante enquanto sao criados os arquivos.');
   Criar_Banco_de_Dados (N);
   Desliga_Mensagem;
  End
 Else
  Begin
   ClrScr;
   Halt;
  End;
End;

Procedure Liste;

 Const
     Ativos = True;
     Inativos = False;

 Var Ch1, Ch2: Char;
     Estado,
     Impressora: Boolean;


Begin
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('[ ] Listar [A]tivos, [I]nativos ou [T]odos.');
 Repeat
  GotoXY (14, 22);
  Ch1:=ReadKey;
 Until (UpCase (Ch1) = 'A') or
       (UpCase (Ch1) = 'I') or
       (UpCase (Ch1) = 'T');
 GotoXY (14, 22);
 Write (Ch1);
 Delay (200);
 Desliga_Mensagem;
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('[ ] Listar na [T]ela ou na [I]mpressora?');
 Repeat
  GotoXY (14, 22);
  Ch2:=ReadKey;
 Until (UpCase (Ch2) = 'T') or
       (UpCase (Ch2) = 'I');
 GotoXY (14, 22);
 Write (Ch2);
 Delay (200);
 Desliga_Mensagem;
 If UpCase (Ch2) = 'I'
  Then Impressora:=True
  Else Impressora:=False;

 Case UpCase (Ch1) of
  'A': Listar (Ativos, Impressora);
  'I': Listar (Inativos, Impressora);
  'T': Begin
        Listar (Ativos, Impressora);
        Listar (Inativos, Impressora);
       End;
 End;
End;

Procedure Alterar;

Var
 Nome: St50;
 Codigo: St8;
 Ch: Char;
 I: Integer;

Begin
 Liga_Mensagem;
 GotoXY (13, 22);
 Write ('Obter reg.por nome ou por codigo? [ ] (N/C).');
 Repeat
  GotoXY (48, 22);
  Ch:=ReadKey;
 Until (UpCase (Ch)='N') or (UpCase (Ch)='C');
 GotoXY (48, 22);
 Write (Ch);
 Delay (200);
 Desliga_Mensagem;
 If (UpCase (Ch) = 'N') Then
  Begin
   Entra_Nome (Nome);
   Busca_por_Nome (Nome, Reg_Principal, I);
  End
 Else
  Begin
   Entra_Codigo (Codigo);
   Busca_por_Codigo (Codigo, Reg_Principal, I);
  End;
   If (I<>-1) Then
     With Reg_Principal do
      Begin
       Mostra_Nome (Nome);
       Mostra_Codigo (Codigo);
       Repeat
        Entra_Artigos (Reg_Principal.Artigos);
        Liga_Mensagem;
        GotoXY (13, 22);
        Write ('Os dados estao corretos? [ ] (S/N).');
        Repeat
         GotoXY (39, 22);
         Ch:=ReadKey;
        Until (UpCase (Ch)='S') or (UpCase (Ch)='N');
        GotoXY (39, 22);
        Write (Ch);
        Delay (200);
        Desliga_Mensagem;
       Until (UpCase (Ch)='S');
       Seek (Arq_Principal, I);
       Escreva_Arq_Principal (Reg_Principal);
      End
     Else
      Begin
       Liga_Mensagem;
       GotoXY (13, 22);
       Write ('Registro nao cadastrado.');
       GotoXY (13, 23);
       Write ('Tecle <Enter> para prosseguir');
       Resp:=ReadKey;
       Desliga_Mensagem;
      End;
 Desliga_Mensagem;
 Limpa_Tela_Interna;
End;


Begin
 InicieTela ('<Menu Principal>');
 {$I-}
 Assign (Arq_Principal,'PRISAO.DAT');
 ReSet (Arq_Principal);
 If IOResult<>0  Then Criar_BD;
 {$I+}
 Iniciar_Utilizacao;
 Repeat
  GotoXY (3, 20);
  Write ('[ ] [I]nserir [P]esquisar [A]lterar [E]xcluir [L]istar [R]eorganizar [F]im');
  Repeat
   GotoXY (4, 20);
   Resp:=ReadKey;
  Until (UpCase (Resp)='I') or
        (UpCase (Resp)='P') or
        (UpCase (Resp)='A') or
        (UpCase (Resp)='E') or
        (UpCase (Resp)='R') or
        (UpCase (Resp)='L') or
        (UpCase (Resp)='F');
  GotoXY (4, 20);
  Write (Resp);
  Case UpCase (Resp) of
   'I': Inserir;
   'P': Pesquisar;
   'A': Alterar;
   'E': Excluir;
   'L': Liste;
   'R': Reorganizar_Banco_de_Dados;
   End;
 Until UpCase (Resp)='F';
Finalizar_Utilizacao;
End.

